﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="ArgumentInjection.aspx.cs" Inherits="ArgumentInjection" %>

<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Argument injection
    </h2>
    <div class="description">
        <p>
            Argument injection is a type of attack performed by changing the input 
            parameters of a page, allowing a user to access data which he normally cannot 
            see. It also includes situations when the user can modify data that they would 
            not be able to change via the user interface, again by means of changing the 
            arguments of the page. Let&#39;s take a look at some examples to better 
            understanding this type of attack.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            In this example, there are two security issues. The first one is that the user 
            can change their password without entering the original one. Imagine a situation 
            where a user forgets to log out on a computer in an Internet café. And more 
            importantly for us right now: is the page vulnerable to argument injection?</p>
        <p>
            Click to this <a href="?username=gold">link</a> to set a sample querystring 
            value (&quot;Sample gold partner&quot; user). Using this querystring parameter, you can 
            set which user will have their password changed.</p>
        <div>
            <asp:TextBox runat="server" ID="txtPassword"></asp:TextBox>
            <asp:Button runat="server" ID="btnConfirm" OnClick="btnConfirm_Click" Text="Change password" />
        </div>
        <p>
            <asp:Label ID="Label1" runat="server" Text=""></asp:Label>
        </p>
    </div>
    <h3>
         How to protect againts it
    </h3>
    <div class="protection">
        <p>
            Let&#39;s take another look at the example above and for now, forget about the issue 
            of not entering the original password. The problem is that anyone can specify 
            any user name. We can solve this by:</p>
        <ul>
            <li>Changing the user name to an identifier which is harder to guess => a GUID.</li>
            <li>Taking the user name from CMSContext.</li>
            <li>Checking that the current user has permissions to change their password.</li>
        </ul>
        <p>
            But what solution should we choose? The ideal solution is a combination of all 
            of them. First, every time you perform an action (displaying a picture is an 
            action too), you must check the user&#39;s permissions. Also, if you can take data 
            from the current context, do not take if from another external source. Data in 
            the current context, for example the information about the current user, is 
            always correct (users cannot manipulate it). And if you have to manipulate 
            non-context data, use GUIDs instead of names or simple IDs.
        </p>
    </div>
</asp:Content>
