﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="SessionFixation.aspx.cs" Inherits="SessionFixation" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Session fixation</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Session fixation
    </h2>
    <div class="description">
        <p>
            In this case, the attacker lets the server generate the right session ID for 
            them. Then, they submit this ID to a regular user and have them use it. This 
            scenario can be achieved quite easily when the session id is given as a url 
            parameter. Once this is done, the user and the attacker share the same session. 
            For example, when a user gets authenticated, the attacker is also authenticated 
            as a user.
        </p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            For this example, it is necessary to set a cookieLess session state in the 
            web.config. The SessionID will now be part of the url.</p>
        <p>
            Please save some value to the text box. Copy the URL of the current page with 
            the sessionID. Now open a different browser, paste this copied URL and click the 
            Read button.
        </p>
        <div>
            <asp:TextBox runat="server" ID="txtValue"></asp:TextBox>
            <asp:Button runat="server" ID="btnSend" Text="Save" />
            <br />
            <br />
            <asp:Button runat="server" ID="btnRead" Text="Read" />
            <br />
            <br />
            <asp:Literal runat="server" ID="ltlSession"></asp:Literal>
        </div>
    </div>
    <h3>
         How to protect againts it
    </h3>
    <div class="protection">
        <p>
            W have to ensure that we do not store any sensitive information in sessions. 
            The best way is to determine which variables are stored in sessions. Then, 
            check how you can manipulate them (read/change) and think about the risks 
            caused by an attacker manipulating with them. You can find these just from 
            the user perspective by looking at the reactions of the application, parameters
             and so on, but we recommend code inspection.</p>
    </div>
</asp:Content>
