﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="UnvalidatedRedirect.aspx.cs" Inherits="UnvalidatedRedirect" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Unvalidated redirect</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Unvalidated redirect
    </h2>
    <div class="description">
        <p>
            In a web application, there are typical situations where a user is redirected 
            from one page to another. For example, after a user logs in, they are redirected 
            to the main page. Where is the catch? If the target of the redirection is 
            inserted as a parameter into the URL of the logon page, it can be changed. The 
            problem is that the attacker could prepare a login link similar to this one: 
            http://www.mysupersecurepage.tld/login.aspx?redirect=http://hackerspage.tld. 
            This link will be posted to a forum at mysecurepage.tld. After that, a user 
            clicks the link, logs in to the regular page and then they are redirected to the 
            attacker&#39;s page. And that&#39;s it.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            This example shows how you can be redirected to another web site.</p>
        <div>
            <p>
                Click <a href="?url=http://www.google.com"> here </a>to set a sample querystring.
            </p>
            <asp:Button runat="server" ID="btnRedirect" Text="Redirect" />
        </div>
    </div>
    <h3>
         How to protect againts it
    </h3>
    <div class="protection">
        <p>
            You have two options here. First, provide the redirection target in a secure 
            way, for example, secure the parameters using a hash. Second, validate if the 
            target of the redirection is a part of your application or not. The protection 
            should look similar to this piece of code:</p>
        <p>
            <code>url.StartsWith("~") || url.StartsWith("/")
            </code>
        </p>
    </div>
</asp:Content>
