﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="SQLiInt.aspx.cs" Inherits="SQLi" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>SQL injection - integer</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        SQL injection - integer
    </h2>
    <div class="description">
        <p>
            SQL injection is a well known web application vulnerability. The attacker&#39;s goal 
            is to execute their own SQL code on the victim&#39;s database through the web 
            application. How can an attacker do that? The attack is similar to XSS, the 
            attacker inserts a special string into the web application via a form or url 
            parameter (…). If that string is used as a dynamic part of an SQL query (e.g. 
            part of the where condition) and not properly protected, the attacker can inject 
            their input into a query before it&#39;s executed.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            Now if a user inserts the number 53, the output displays the full name of the 
            global administrator.</p>
        <p>
            But what if a user inserts something like "53;DROP table CMS_User --" ?
        </p>
        <br />
        <div>
            <asp:Label ID="lbluserName" runat="server" Text="UserID :"></asp:Label>
            <asp:TextBox ID="txtUserID" runat="server"></asp:TextBox>
            <asp:Button ID="btnSearch" runat="server" Text="Search" OnClick="btnSearch_Click" />
        </div>
        <p>
            Result: <asp:Label ID="Label1" runat="server" Text=""></asp:Label>
        </p>
    </div>
    <h3>
        How to protect against it
    </h3>
    <div class="protection">
        <p>
            There are many ways of protection. In Kentico CMS we use SQL parameter and 
            apostrophe escaping.</p>
        <p>
            For INSERT/UPDATE/DELETE queries, we use protection via SQL parameters, but for 
            SELECT queries and places that build WHERE conditions out of strings, we use 
            apostrophe escaping protection.</p>
        <p>
            However, in this example protection via apostrophe escaping is useless, because 
            the value of the textbox isn&#39;t used in the output. So for this type of input, it 
            is necessary to use our ValidationHelper class.</p>
    </div>
</asp:Content>
