﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="SQLiIntUseless.aspx.cs" Inherits="SQLi" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Protection by apostrophe escaping</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Protection by apostrophe escaping
    </h2>
    <div class="description">
        <p>
            This page is the same as <a href="SQLiInt.aspx">SQL injection - integer</a>,
            but protected against this type of attack.
        </p>
        <p>
            SQL injection is a well known web application vulnerability. The attacker&#39;s goal 
            is to execute their own SQL code on the victim&#39;s database through the web 
            application. How can an attacker do that? The attack is similar to XSS, the 
            attacker inserts a special string into the web application via a form or url 
            parameter (…). If that string is used as a dynamic part of an SQL query (e.g. 
            part of the where condition) and not properly protected, the attacker can inject 
            their input into a query before it&#39;s executed.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            Now if a user inserts the number 53, the output displays the full name of the 
            global administrator.</p>
        <p>
            But what if a user inserts something like "53;DROP table CMS_User --" ?
        </p>
        <br />
        <div>
            <asp:Label ID="lbluserName" runat="server" Text="userID:"></asp:Label>
            <asp:TextBox ID="txtUserID" runat="server"></asp:TextBox>
            <asp:Button ID="btnSearch" runat="server" Text="Search" OnClick="btnSearch_Click" />
        </div>
        <p>
            Result: <asp:Label ID="Label1" runat="server" Text=""></asp:Label>
        </p>
    </div>
    <h3>
        Why is this page secure against SQLi?
    </h3>
    <div class="protection">
        <p>
            The number from the textbox is validated by one of our validation methods from 
            the ValidationHelper class: GetInteger()</p>
        <p>
            If input can be string, it is necessary to use string.Replace("'", "''")
        </p>
    </div>
</asp:Content>
