﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="SQLiProcedure.aspx.cs" Inherits="SQLiProcedure" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Protection by SQL Parameters</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Protection by SQL Parameters</h2>
    <div class="description">
        <p>
            Let&#39;s take a look at queries with SQL parameters. The second parameter of 
            ExecuteQuery() is an N-dimensional array. To fill this parameter in code, we use 
            a three dimensional array. The first dimension of the inner array is used for 
            the parameter name and the second as its value. The third parameter is for 
            special handling. Its exact meaning is not important for the purposes of this 
            paper.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            A query using parameters should look like this: INSERT INTO table1 VALUES(@param,
            @param2) ; 
            <br />
            <br />
            In code, you should fill the array like this:
            <br />
            <br />
            <code>params[0, 0] = "@param";
                <br />
                params[0, 1] = "value1";<br />
                params[1, 0] = "@param";<br />
                params[1, 1] = "value2";
                <br />
            </code>
            <br />
            The SQL server simply replaces @param with your value. An important fact is that 
            the value is treated as a literal. This means that even if your value contains 
            SQL code, the SQL server doesn&#39;t execute it. Parameters are almost 100% secure. 
            BUT if you build another query from parameters, which is executed using the 
            built-in exec() function, parameters are taken the standard way. Look at the 
            sample procedure below that shows a typical example of how NOT to do it.</p>
        <asp:Button ID="Button1" runat="server" Text="Create procedure" OnClick="Button1_Click" />
        <p>
            Now if a user inserts &quot;CMS_User&quot;, the output displays data from the CMS_User 
            table.</p>
        <p>
            But what if a user inserts something like "CMS_User;DROP TABLE CMS_User" ?</p>
        <br />
        <div>
            <asp:TextBox ID="TextBox1" runat="server"></asp:TextBox>
            <asp:Button ID="Button2" runat="server" Text="Execute procedure" OnClick="Button2_Click" />
        </div>
        <p>
            Result: <asp:Label ID="Label1" runat="server" Text=""></asp:Label>
        </p>
    </div>
    <h3>
         How to protect againts it
    </h3>
    <div class="protection">
        <p>
            Don’t ever use the exec() function in your SQL code.
            When you work with other than string types, always convert data types to that type or validate the value via regular expressions.
        </p>
    </div>
</asp:Content>
