﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="XSSNonPersistent2.aspx.cs" Inherits="NonPersistentXSS" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Non-persistent XSS 2</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Non-persistent XSS 2
    </h2>
    <div class="description">
        <p>
            XSS is when you enter some malicious input into a form (for example partial html 
            code). Non-persistent XSS is basically very similar to persistent XSS. The main 
            difference in this case is that the web application (like an instance of Kentico 
            CMS) doesn&#39;t store the input to the database. Instead of storing it, the 
            application renders the input directly as part of a response.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            This example shows how some code which dynamically generates JavaScript can be 
            hacked
        </p>
        <p>
            It is not necessary to type the complete XSS script into the querystring.</p>
        <div>
            <div id="attack" class="attack">
                The background of this div will be changed if you click <a href="?dynamic=element=document.getElementById('attack');element.style.backgroundColor='red'">
                    here</a> but if you click <a href="?dynamic=alert('XSS hacked !!')">here</a>, 
                an
                XSS will be executed by the same script.
            </div>
            <p>
                Here is the label where the text from the querystring is placed: "<asp:Literal ID="ltlScript"
                    runat="server" EnableViewState="false" />"
            </p>
        </div>
    </div>
    <h3>
        How to protect against it
    </h3>
    <div class="protection">
        <p>
            This example works because the dynamic parts of the code (input, database data, 
            …) weren&#39;t properly encoded. So, everything that ends up in the output (renders 
            to html) MUST be properly HTML/javascript encoded. What does properly encoded 
            mean? These methods help you avoiding XSS:
        </p>
        <ul>
            <li><strong>HttpUtility.HtmlEncode(String) </strong>– Converts a string to an HTML-encoded string. </li>
            <li><strong>HttpUtility.UrlEncode(String)</strong> – Encodes a URL string. </li>
        </ul>
    </div>
</asp:Content>
