﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using CMS.GlobalHelper;

public partial class NonPersistentXSS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string dynamic = Request.QueryString["dynamic"];
        if (dynamic != "")
        {
            this.ltlScript.Text = GetScript(dynamic);
        }
    }

    /// <summary>
    /// Encloses the specified script in an HTML script element.
    /// </summary>
    /// <param name="script">Script block to enclose in a element</param>
    public static string GetScript(string script)
    {
        // No script, no code
        if (string.IsNullOrEmpty(script))
        {
            return null;
        }

        return string.Format(@"
<script type=""text/javascript"">
	{0}
</script>", script);
    }
}
