﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="XSSNonPersistentProtected.aspx.cs" Inherits="NonPersistentXSS" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Protection againts non-persistent XSS</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
       Protection againts non-persistent XSS
    </h2>
    <div class="description">
        <p>
            This page is the same as <a href="XSSNonPersistent.aspx">Non-persistent XSS</a>,
            but protected against this type of attack.
        </p>
        <p>
            XSS is when you enter some malicious input into a form (for example partial html 
            code). Non-persistent XSS is basically very similar to persistent XSS. The main 
            difference in this case is that the web application (like an instance of Kentico 
            CMS) doesn&#39;t store the input to the database. Instead of storing it, the 
            application renders the input directly as part of a response.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            If you click the links below, you will be redirected to this page with a 
            querystring parameter.</p>
        <div>
            <p>
                <a href="?info=normal text">Click here</a> to show normal text.
                <br />
                <a href="?info=<script>alert(1)</script>">Click here</a> to show an attempted XSS attack.
                <br />
            </p>
            <p>
                Here is label where is text from querystring placed : "<asp:Label ID="lblInfo" runat="server"
                    EnableViewState="false" CssClass="InfoLabel" />"
            </p>
        </div>
    </div>
    <h3>
        Why is this page secure against XSS?
    </h3>
    <div class="protection">
        <p>
            It&#39;s quite simple. The value from the querystring is taken using the 
            QueryHelper.GetString() method, so potentially dangerous characters are replaced 
            by their HTML entities.
        </p>
    </div>
</asp:Content>
