﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="XSSPersistent.aspx.cs" Inherits="XSSPersistent" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Persistent XSS</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Persistent XSS
    </h2>
    <div class="description">
        <p>
            XSS is when you insert some malicious input into form (for example partial html code).
            Then, the input is stored in the database and this value (malicious input) can 
            be rendered on another page. The browser renders attacker's input as part of its html and that's
            it. This type is called persistent XSS.
        </p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            This sample form inserts a new user into the database with some username and 
            first name. Below the textboxes is a list of the last 5 inserted users.</p>
        <p>
            Try to insert &quot;aaa&quot; as the First name and then &quot;&lt;script&gt;alert(1)&lt;/script&gt;&quot;.
        </p>
        <br />
        <div>
            <table>
                <tr>
                    <td>
                        Username:
                        <asp:TextBox runat="server" ID="txtUserName"></asp:TextBox>
                    </td>
                    <td>
                        First name:
                        <asp:TextBox runat="server" ID="txtFirstName"></asp:TextBox>
                    </td>
                    <td>
                        <asp:Button runat="server" ID="btnAddUser" Text="Add user" OnClick="btnAddUser_Click" />
                    </td>
                </tr>
            </table>
            <p>
                <u>Result (UserName | FirstName):</u>
                <br />
                <asp:Label runat="server" ID="lblUser"></asp:Label>
            </p>
        </div>
    </div>
    <h3>
        How to protect against it
    </h3>
    <div class="protection">
        <p>
            This example works because the dynamic parts of the code (input, database data, 
            …) weren&#39;t properly encoded. So, everything that ends up in the output (renders 
            to html) MUST be properly HTML/javascript encoded. What does properly encoded 
            mean? These methods help you avoiding XSS:
        </p>
        <ul>
            <li><strong>HTTPUtility.HTMLEncode(String) </strong>– Converts a string to an HTML-encoded string. </li>
            <li><strong>HTTPUtility.UrlEncode(String)</strong> – Encodes a URL string. </li>
        </ul>
    </div>
</asp:Content>
