﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="XSSPersistentProtected.aspx.cs" Inherits="XSSPersistent" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Protection against persistent XSS</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Protection against persistent XSS
    </h2>
    <div class="description">
        <p>
            This page is the same as <a href="XSSPersistent.aspx">Persistent XSS</a>, but protected 
            against this type of attack.
        </p>
        <p>
            XSS is when you enter some malicious input into a form (for example partial html 
            code). Then, the input is stored in the database and this value (malicious 
            input) can be rendered on another page. The browser renders the attacker&#39;s input 
            as part of its html and that&#39;s it. This type of attack is called persistent XSS.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            This sample form inserts a new user into the database with some username and 
            first name. Below the textboxes is a list of the last 5 inserted users.</p>
        <p>
            Try to insert &quot;aaa&quot; as the First name and then &quot;&lt;script&gt;alert(1)&lt;/script&gt;&quot;</p>
        <br />
        <div>
            <table>
                <tr>
                    <td>
                        Username:
                        <asp:TextBox runat="server" ID="txtUserName"></asp:TextBox>
                    </td>
                    <td>
                        First name:
                        <asp:TextBox runat="server" ID="txtFirstName"></asp:TextBox>
                    </td>
                    <td>
                        <asp:Button runat="server" ID="btnAddUser" Text="Add user" OnClick="btnAddUser_Click" />
                    </td>
                </tr>
            </table>
            <p>
                <u>Result (UserName | FirstName):</u>
                <br />
                <asp:Label runat="server" ID="lblUser"></asp:Label>
            </p>
        </div>
    </div>
    <h3>
        Why is this page secure against XSS?
    </h3>
    <div class="protection">
        <p>
            It&#39;s quite simple. The output of the FirstName textbox is encoded using the 
            HTMLHelper.HTMLEncode() method, so potentially dangerous characters are replaced 
            by their HTML entities.
        </p>
    </div>
</asp:Content>
