﻿<%@ Page Language="C#" MasterPageFile="~/SecurityExamples/SecurityMaster.master"
    AutoEventWireup="true" CodeFile="XSSNonPersistent3.aspx.cs" Inherits="XSSNonPersistent3" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
    <title>Non-persistant XSS 3</title>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <h2>
        Non-persistant XSS 3
    </h2>
    <div class="description">
        <p>
            XSS is when you enter some malicious input into a form (for example partial html
            code). Non-persistent XSS is basically very similar to persistent XSS. The main
            difference in this case is that the web application (like an instance of Kentico
            CMS) doesn&#39;t store the input to the database. Instead of storing it, the application
            renders the input directly as part of a response.</p>
    </div>
    <h3>
        How it works
    </h3>
    <div class="works">
        <p>
            This example shows that other types of input, such as a url referrer, can be 
            exploited in order to perform an attack.</p>
        <div>
            URL Referrer : "<asp:Literal runat="server" ID="lblShowReferer" EnableViewState="false"></asp:Literal>"
        </div>
    </div>
    <h3>
        How to protect against it
    </h3>
    <div class="protection">
        <p>
            This example works because the dynamic parts of the code (input, database data,
            …) weren&#39;t properly encoded. So, everything that ends up in the output (renders
            to html) MUST be properly HTML/javascript encoded. What does properly encoded mean?
            These methods help you avoiding XSS:
        </p>
        <ul>
            <li><strong>HttpUtility.HtmlEncode(String) </strong>– Converts a string to an HTML-encoded string. </li>
            <li><strong>HttpUtility.UrlEncode(String)</strong> – Encodes a URL string. </li>
        </ul>
    </div>
</asp:Content>
